program isegment
!! Capture the label from a map file
!! and display it
!! GeoFOld CGI server
!! C.Bystroff Fri Jul 25 08:06:35 EDT 2008
  implicit none
  character(len=200) :: aline, basename
  character(len=200) :: label, dagfile
  character(len=200) :: outputurl
  character(len=4) :: code
  integer :: pid, ios, i,j
  outputurl = 'output/'
  !!---------
  !! uses method="POST" 
  !!---------------------
  !! UNCOMMENT TO DEBUG
  !write(*,'(a,//)') 'Content-type: text/html'
  !  write(*,'(a)') "<html>"
  !  write(*,'(a)') "<body>"
  !  write(*,'(a)') "<pre>"
  !call system("set")
  !  write(*,'(a)') "</pre>"
  !  write(*,'(a)') "</body>"
  !  write(*,'(a)') "</html>"
  !stop
  !!---------------------
  ! read(*,*) aline
  call getenv("QUERY_STRING",aline)
  call parseit(aline,"iseg",label)
  call parseit(aline,"dag",dagfile)
  ! call singlelineoutput(label)
  call readdagfile(label,dagfile)
  i = index(dagfile,'/',.true.)+1
  j = index(dagfile,'.dag',.true.)-1
  basename = dagfile(i:j)
  write(*,'("<h4><A HREF=",a,">Back to main</A></h4>")') &
          '"'//trim(outputurl)//trim(basename)//'.html"'
  write(*,'(a)') "</body>"
  write(*,'(a)') "</html>"
CONTAINS
  !---------------------------------------------
  subroutine parseit(aline,atag,result)
    character(len=*),intent(in) :: aline, atag
    character(len=*),intent(out) :: result
    integer :: i,j,ich, k
    i = index(aline,atag)
    ! write(*,*) aline(1:i)
    j = i + len(atag)+1
    k = index(aline(j:),'&')
    result = aline(j:j+k-2)
    ! write(*,*) trim(result)
  end subroutine parseit
  !---------------------------------------------
  subroutine errormsg(atag,entry)
    character(len=*),intent(in) :: atag,entry
    write(*,'(a,//)') 'Content-type: text/html'
    write(*,'(a)') '<meta http-equiv="refresh" content="30;url=server.php">'
    write(*,'(a)') "<html>"
    write(*,'(a)') "<body>"
    write(*,'(a,a)') '<font color="#FF0000">ERROR! Please enter a valid </font>',trim(atag)
    write(*,'(a,a,a)') 'You entered "',trim(entry),'" </font>'
    write(*,'(a)') '<h2><A HREF="server.php">try again</A></h2>'
    write(*,'(a)') "</body>"
    write(*,'(a)') "</html>"
    stop
  end subroutine errormsg
  !---------------------------------------------
  subroutine istatelineoutput(line1,line2,line3,dagfile)
    !! Output HTML for ISEGMT, plus links to TSTATEs
    !! Example ISEGMT line:
    !!ISEGMT     104    5    0      624.24       11.28       0     0       U  0.01686023
    character(len=*),intent(in) :: line1, line2, line3, dagfile
    integer :: i,j,k,m,nseg,nvoid,nhb,dunit=22,ios=0,nts,f,u1,u2,nsym,nres,nch
    real :: conc, sas, ntrp
    character(len=1) :: ftype, lstch
    character(len=1000) :: aline
    !!
    read(line1(7:),*) nseg,i,nsym,sas,ntrp,nvoid,nhb,ftype,conc
    write(*,'(a,//)') 'Content-type: text/html'
    write(*,'(a)') "<html>"
    write(*,'(a)') "<body>"
    write(*,'(a,a,a)') '<font color="#11AA55"><pre>',trim(line1),'</pre></font>'
    write(*,'(a,a,a)') '<font color="#AA1155"><pre>',trim(line2),'</pre></font>'
    write(*,'(a,a,a)') '<font color="#555555"><pre>',trim(line3),'</pre></font>'
    write(*,'("<br><b>Segment node ",i9,"</b>")') nseg
    select case (ftype)
      case ("F")
        write(*,'("FOLDED STATE")')
      case ("I")
        write(*,'("INTERMEDIATE STATE")')
      case ("U")
        write(*,'("UNFOLDED STATE")')
    end select
    nres = 0
    nch = 0
    lstch = "."
    do i=1,index(line2," ")-1
      if (line2(i:i)/='.') then
        nres = nres + 1
        if (lstch/=line2(i:i)) nch = nch + 1
      endif
      lstch = line2(i:i)
    enddo
    write(*,'("<br>Size      = ",i0)') nres
    write(*,'("<br>Number of chains = ",i0)') nch
    write(*,'("<br>Symmetry-generated copies    = ",i0)') nsym
    write(*,'("<br>Total buried surface area    = ",f9.2)') sas
    write(*,'("<br>Total unexpressed sidechain entropy    = ",f9.2)') ntrp
    write(*,'("<br>Total remaining buried voids = ",i0)') nvoid
    write(*,'("<br>Total remaining H-bonds = ",i0)') nhb
    write(*,'("<br>Concentration at end of simulation= ",f9.6)') conc
    open(dunit,file=dagfile,form='formatted',status='old',iostat=ios)
    if (ios/=0) stop 'Error opening dagfile.'
    write(*,'("<h5>Transition states (folding)</h5>")') 
    write(*,'("<pre>")') 
    write(*,'(7x,4a7)') "tstate","f","u1","u2"
    do
      read(dunit,'(a)',iostat=ios) aline
      if (ios/=0) exit
      if (aline(1:6)/="TSTATE") cycle
      read(aline(7:),*) nts,f,u1,u2
      if (u1==nseg.or.u2==nseg) then
         write(*,'(a7,4(a,i0,a,i7,a),a)') aline(1:7),&
           '<A HREF="isegment.cgi?iseg=tu',nts,'&dag='//trim(dagfile)//'&">',nts,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',f,'&dag='//trim(dagfile)//'&">',f,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',u1,'&dag='//trim(dagfile)//'&">',u1,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',u2,'&dag='//trim(dagfile)//'&">',u2,'</A>', &
           trim(aline(36:))
      endif
    enddo
    write(*,'("</pre>")') 
    rewind(dunit)
    write(*,'("<h5>Transition states (unfolding)</h5>")')
    write(*,'("<pre>")') 
    write(*,'(7x,4a7)') "tstate","f","u1","u2"
    do
      read(dunit,'(a)',iostat=ios) aline
      if (ios/=0) exit
      if (aline(1:6)/="TSTATE") cycle
      read(aline(7:),*) nts,f,u1,u2
      if (f==nseg) then
         write(*,'(a7,4(a,i0,a,i7,a),a)') aline(1:7),&
           '<A HREF="isegment.cgi?iseg=tu',nts,'&dag='//trim(dagfile)//'&">',nts,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',f,'&dag='//trim(dagfile)//'&">',f,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',u1,'&dag='//trim(dagfile)//'&">',u1,'</A>', &
           '<A HREF="isegment.cgi?iseg=n',u2,'&dag='//trim(dagfile)//'&">',u2,'</A>', &
           trim(aline(36:))
      endif
    enddo
    write(*,'("</pre>")') 
    close(dunit)
    !write(*,'(a)') "</body>"
    !write(*,'(a)') "</html>"
  end subroutine istatelineoutput
  !---------------------------------------------
  subroutine tstatelineoutput(entry,dagfile)
    character(len=*),intent(in) :: entry
    character(len=*),intent(in) :: dagfile
    character(len=20) :: cuttype
    integer :: nts,f,u1,u2
    real :: ntrp, traf
    character :: ctype
    !!----
    read(entry(7:),*) nts,f,u1,u2,ntrp,ctype,traf
    select case (ctype)
      case ("h")
        cuttype = "HINGE"
      case ("p")
        cuttype = "PIVOT"
      case ("b")
        cuttype = "BREAK"
      case ("m")
        cuttype = "MELTING"
      case default
        cuttype ="UNKNOWN CUTTYPE"
    end select
    write(*,'(a,//)') 'Content-type: text/html'
    write(*,'(a)') "<html>"
    write(*,'(a)') "<body>"
    write(*,'(a,a,a)') '<font color="#000055"><pre>',trim(entry),'</pre></font>'
    write(*,'("<br><b>Transition state ",i9,"</b>&nbsp;",a)') nts,trim(cuttype)
    write(*,'("<br>folded state node number     =<A HREF=",a,i0,a,">",i0,"</A>")') &
           '"'//'isegment.cgi?iseg=n',f,'&dag='//trim(dagfile)//'&"',f
    write(*,'("<br>unfolded state 1 node number =<A HREF=",a,i0,a,">",i0,"</A>")') &
           '"'//"isegment.cgi?iseg=n",u1,"&dag="//trim(dagfile)//'&"',u1
    write(*,'("<br>unfolded state 2 node number =<A HREF=",a,i0,a,">",i0,"</A>")') &
           '"'//"isegment.cgi?iseg=n",u2,"&dag="//trim(dagfile)//'&"',u2
    if (scan(ctype,"hpb")/=0) then
        write(*,'("<br>",a,": entropy = ",f8.3)') trim(cuttype),ntrp
    endif
    write(*,'("<br>Relative traffic =",f8.3)') traf
    !write(*,'(a)') "</body>"
    !write(*,'(a)') "</html>"
  end subroutine tstatelineoutput
  !---------------------------------------------
  subroutine singlelineoutput(entry)
    character(len=*),intent(in) :: entry
    write(*,'(a,//)') 'Content-type: text/html'
    write(*,'(a)') "<html>"
    write(*,'(a)') "<body>"
    write(*,'(a,a,a)') '<font color="#000055"><pre>',trim(entry),'</pre></font>'
    write(*,'(a)') "</body>"
    write(*,'(a)') "</html>"
    stop
  end subroutine singlelineoutput
  !---------------------------------------------
  subroutine readdagfile(label,dagfile)
    character(len=*),intent(in) :: label, dagfile
    character(len=2000) :: aline,bline,sline
    integer :: ios, inode, i, dunit=22
    logical :: iststate
    !! 
    open(dunit,file=dagfile,form='formatted',status='old',iostat=ios)
    if (ios/=0 ) call singlelineoutput(entry="DAG file is missing: "//trim(dagfile))
    if (label(1:1)=="t") then
      read(label(3:),*,iostat=ios) inode
      if (ios/=0 ) call singlelineoutput(entry="ERROR parsing tstate node label: "//trim(label))
      iststate = .true.
    elseif (label(1:1)=="n") then
      read(label(2:),*,iostat=ios) inode
      if (ios/=0 ) &
      call singlelineoutput(entry="ERROR parsing intermediate node label: "//trim(label))
      iststate = .false.
    else
      call singlelineoutput(entry="ERROR bad node label: "//trim(label))
    endif
    !! read DAG file
    do
      read(dunit,'(a)',iostat=ios) aline
      if (ios/=0) exit
      if (aline(1:8)=="SEQUENCE") then
        sline = aline(15:)
        cycle
      endif
      if (iststate) then
        if (aline(1:6)/="TSTATE") cycle
        read(aline(7:14),*,iostat=ios) i
        if (ios/=0 ) call singlelineoutput("ERROR parsing dagfile : "//trim(aline))
        if (i==inode) then
          close(dunit)  !! must close, because file will be opened in the subroutine
          call tstatelineoutput(aline,dagfile)
          return    !! must return, because file is closed.
        endif
      else
        if (aline(1:6)/="ISEGMT") cycle
        read(aline(7:14),*,iostat=ios) i
        read(dunit,'(a)',iostat=ios) bline
        if (ios/=0 ) call singlelineoutput("ERROR parsing dagfile : "//trim(aline))
        if (i==inode) then
          close(dunit)  !! must close, because file will be opened in the subroutine
          call istatelineoutput(aline,bline,sline,dagfile)
          return    !! must return, because file is closed.
        endif
      endif
    enddo
    call singlelineoutput("ERROR parsing dagfile : "//trim(dagfile)//"  Node line not found.")
    close(dunit)  !! If here, there is a bug.
  end subroutine readdagfile
end program isegment
